Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Transformations/TransformationToSymbolicTreeMapper.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Transformations/TransformationToSymbolicTreeMapper.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/Transformations/TransformationToSymbolicTreeMapper.cs	(revision 18132)
@@ -84,5 +84,5 @@
       // k * x
       var multiplicationNode = new Multiplication().CreateTreeNode();
-      var kNode = CreateConstantTreeNode("k", kValue);
+      var kNode = CreateNumber("k", kValue);
       var xNode = CreateVariableTreeNode(column, "x");
       multiplicationNode.AddSubtree(kNode);
@@ -91,5 +91,5 @@
       // ( k * x ) + d
       var additionNode = new Addition().CreateTreeNode();
-      var dNode = CreateConstantTreeNode("d", dValue);
+      var dNode = CreateNumber("d", dValue);
       additionNode.AddSubtree(multiplicationNode);
       additionNode.AddSubtree(dNode);
@@ -105,5 +105,5 @@
       // x - d
       var substractionNode = new Subtraction().CreateTreeNode();
-      var dNode = CreateConstantTreeNode("d", dValue);
+      var dNode = CreateNumber("d", dValue);
       var xNode = CreateVariableTreeNode(column, "x");
       substractionNode.AddSubtree(xNode);
@@ -112,5 +112,5 @@
       // ( x - d ) / k
       var divisionNode = new Division().CreateTreeNode();
-      var kNode = CreateConstantTreeNode("k", kValue);
+      var kNode = CreateNumber("k", kValue);
       divisionNode.AddSubtree(substractionNode);
       divisionNode.AddSubtree(kNode);
@@ -157,5 +157,5 @@
       var powerNode = new Power().CreateTreeNode();
       var xNode = CreateVariableTreeNode(column, "x");
-      var expNode = CreateConstantTreeNode("exp", expValue);
+      var expNode = CreateNumber("exp", expValue);
       powerNode.AddSubtree(xNode);
       powerNode.AddSubtree(expNode);
@@ -171,5 +171,5 @@
       var rootNode = new Root().CreateTreeNode();
       var xNode = CreateVariableTreeNode(column, "x");
-      var bNode = CreateConstantTreeNode("b", expValue);
+      var bNode = CreateNumber("b", expValue);
       rootNode.AddSubtree(xNode);
       rootNode.AddSubtree(bNode);
@@ -220,5 +220,5 @@
       // log(x, b)
       var logNode = new Logarithm().CreateTreeNode();
-      var bNode = CreateConstantTreeNode("b", b);
+      var bNode = CreateNumber("b", b);
       var xNode = CreateVariableTreeNode(column, "x");
       logNode.AddSubtree(xNode);
@@ -231,5 +231,5 @@
       // b ^ x
       var powerNode = new Power().CreateTreeNode();
-      var bNode = CreateConstantTreeNode("b", b);
+      var bNode = CreateNumber("b", b);
       var xNode = CreateVariableTreeNode(column, "x");
       powerNode.AddSubtree(bNode);
@@ -242,5 +242,5 @@
       // 1 / x
       var divNode = new Division().CreateTreeNode();
-      var oneNode = CreateConstantTreeNode("1", 1.0);
+      var oneNode = CreateNumber("1", 1.0);
       var xNode = CreateVariableTreeNode(column, "x");
       divNode.AddSubtree(oneNode);
@@ -254,5 +254,5 @@
       var substractionNode = new Subtraction().CreateTreeNode();
       var xNode = CreateVariableTreeNode(variable, "x");
-      var m_orgNode = CreateConstantTreeNode("m_org", m_org);
+      var m_orgNode = CreateNumber("m_org", m_org);
       substractionNode.AddSubtree(xNode);
       substractionNode.AddSubtree(m_orgNode);
@@ -260,5 +260,5 @@
       // (x - m_org) / s_org
       var divisionNode = new Division().CreateTreeNode();
-      var s_orgNode = CreateConstantTreeNode("s_org", s_org);
+      var s_orgNode = CreateNumber("s_org", s_org);
       divisionNode.AddSubtree(substractionNode);
       divisionNode.AddSubtree(s_orgNode);
@@ -266,5 +266,5 @@
       // ((x - m_org) / s_org ) * s_tar
       var multiplicationNode = new Multiplication().CreateTreeNode();
-      var s_tarNode = CreateConstantTreeNode("s_tar", s_tar);
+      var s_tarNode = CreateNumber("s_tar", s_tar);
       multiplicationNode.AddSubtree(divisionNode);
       multiplicationNode.AddSubtree(s_tarNode);
@@ -272,5 +272,5 @@
       // ((x - m_org) / s_org ) * s_tar + m_tar
       var additionNode = new Addition().CreateTreeNode();
-      var m_tarNode = CreateConstantTreeNode("m_tar", m_tar);
+      var m_tarNode = CreateNumber("m_tar", m_tar);
       additionNode.AddSubtree(multiplicationNode);
       additionNode.AddSubtree(m_tarNode);
@@ -279,6 +279,6 @@
     }
 
-    private ConstantTreeNode CreateConstantTreeNode(string description, double value) {
-      return new ConstantTreeNode(new Constant()) { Value = value };
+    private NumberTreeNode CreateNumber(string description, double value) {
+      return new NumberTreeNode(new Number()) { Value = value };
     }
 
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeBottomUpSimilarityCalculator.cs	(revision 18132)
@@ -41,5 +41,5 @@
     protected override bool IsCommutative { get { return true; } }
 
-    public bool MatchConstantValues { get; set; }
+    public bool MatchParameterValues { get; set; }
     public bool MatchVariableWeights { get; set; }
 
@@ -66,14 +66,13 @@
 
     public static double CalculateSimilarity(ISymbolicExpressionTreeNode n1, ISymbolicExpressionTreeNode n2, bool strict = false) {
-      var calculator = new SymbolicExpressionTreeBottomUpSimilarityCalculator { MatchConstantValues = strict, MatchVariableWeights = strict };
       return CalculateSimilarity(n1, n2, strict);
     }
 
-    public static Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> ComputeBottomUpMapping(ISymbolicExpressionTree t1, ISymbolicExpressionTree t2, bool strict = false) {
+    public static NodeMap ComputeBottomUpMapping(ISymbolicExpressionTree t1, ISymbolicExpressionTree t2, bool strict = false) {
       return ComputeBottomUpMapping(ActualRoot(t1), ActualRoot(t2), strict);
     }
 
-    public static Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> ComputeBottomUpMapping(ISymbolicExpressionTreeNode n1, ISymbolicExpressionTreeNode n2, bool strict = false) {
-      var calculator = new SymbolicExpressionTreeBottomUpSimilarityCalculator { MatchConstantValues = strict, MatchVariableWeights = strict };
+    public static NodeMap ComputeBottomUpMapping(ISymbolicExpressionTreeNode n1, ISymbolicExpressionTreeNode n2, bool strict = false) {
+      var calculator = new SymbolicExpressionTreeBottomUpSimilarityCalculator { MatchParameterValues = strict, MatchVariableWeights = strict };
       return calculator.ComputeBottomUpMapping(n1, n2);
     }
@@ -81,5 +80,5 @@
 
     public double CalculateSimilarity(ISymbolicExpressionTree t1, ISymbolicExpressionTree t2) {
-      return CalculateSimilarity(t1, t2, out Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> map);
+      return CalculateSimilarity(t1, t2, out _);
     }
 
@@ -110,9 +109,9 @@
     }
 
-    public Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> ComputeBottomUpMapping(ISymbolicExpressionTree t1, ISymbolicExpressionTree t2) {
+    public NodeMap ComputeBottomUpMapping(ISymbolicExpressionTree t1, ISymbolicExpressionTree t2) {
       return ComputeBottomUpMapping(ActualRoot(t1), ActualRoot(t2));
     }
 
-    public Dictionary<ISymbolicExpressionTreeNode, ISymbolicExpressionTreeNode> ComputeBottomUpMapping(ISymbolicExpressionTreeNode n1, ISymbolicExpressionTreeNode n2) {
+    public NodeMap ComputeBottomUpMapping(ISymbolicExpressionTreeNode n1, ISymbolicExpressionTreeNode n2) {
       var compactedGraph = Compact(n1, n2);
 
@@ -211,6 +210,6 @@
         return node.Symbol.Name;
 
-      if (node is ConstantTreeNode constant)
-        return MatchConstantValues ? constant.Value.ToString(CultureInfo.InvariantCulture) : constant.Symbol.Name;
+      if (node is INumericTreeNode numNode)
+        return MatchParameterValues ? numNode.Value.ToString(CultureInfo.InvariantCulture) : "Numeric";
 
       if (node is VariableTreeNode variable)
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeMaxCommonSubtreeSimilarityCalculator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeMaxCommonSubtreeSimilarityCalculator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeMaxCommonSubtreeSimilarityCalculator.cs	(revision 18132)
@@ -38,7 +38,7 @@
     }
 
-    public bool MatchConstantValues {
-      get { return comparer.MatchConstantValues; }
-      set { comparer.MatchConstantValues = value; }
+    public bool MatchParameterValues {
+      get { return comparer.MatchParameterValues; }
+      set { comparer.MatchParameterValues = value; }
     }
 
@@ -59,5 +59,5 @@
     public SymbolicExpressionTreeMaxCommonSubtreeSimilarityCalculator() {
       comparer = new SymbolicExpressionTreeNodeEqualityComparer {
-        MatchConstantValues = true,
+        MatchParameterValues = true,
         MatchVariableNames = true,
         MatchVariableWeights = true
@@ -65,7 +65,7 @@
     }
 
-    public SymbolicExpressionTreeMaxCommonSubtreeSimilarityCalculator(bool matchVariableWeights, bool matchConstantValues) {
+    public SymbolicExpressionTreeMaxCommonSubtreeSimilarityCalculator(bool matchVariableWeights, bool matchParameterValues) {
       comparer = new SymbolicExpressionTreeNodeEqualityComparer {
-        MatchConstantValues = matchConstantValues,
+        MatchParameterValues = matchParameterValues,
         MatchVariableNames = true,
         MatchVariableWeights = matchVariableWeights
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeComparer.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeComparer.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeComparer.cs	(revision 18132)
@@ -28,5 +28,5 @@
   // this comparer considers that a < b if the type of a is "greater" than the type of b, for example:
   // - A function node is "greater" than a terminal node
-  // - A variable terminal is "greater" than a constant terminal
+  // - A variable terminal is "greater" than a numeric terminal
   // - used for bringing subtrees to a "canonical" form when the operation allows reordering of arguments
   public class SymbolicExpressionTreeNodeComparer : ISymbolicExpressionTreeNodeComparer {
@@ -52,6 +52,6 @@
 
       // at this point we know a and b are not variables
-      var ca = a as ConstantTreeNode;
-      var cb = b as ConstantTreeNode;
+      var ca = a as INumericTreeNode;
+      var cb = b as INumericTreeNode;
 
       if (ca != null && cb != null)
Index: /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeEqualityComparer.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeEqualityComparer.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis.Symbolic/3.4/TreeMatching/SymbolicExpressionTreeNodeEqualityComparer.cs	(revision 18132)
@@ -33,5 +33,5 @@
     protected SymbolicExpressionTreeNodeEqualityComparer(SymbolicExpressionTreeNodeEqualityComparer original, Cloner cloner)
       : base(original, cloner) {
-      matchConstantValues = original.matchConstantValues;
+      matchParameterValues = original.matchParameterValues;
       matchVariableNames = original.matchVariableNames;
       matchVariableWeights = original.matchVariableWeights;
@@ -41,8 +41,8 @@
     // more flexible matching criteria 
     [Storable]
-    private bool matchConstantValues;
-    public bool MatchConstantValues {
-      get { return matchConstantValues; }
-      set { matchConstantValues = value; }
+    private bool matchParameterValues;
+    public bool MatchParameterValues {
+      get { return matchParameterValues; }
+      set { matchParameterValues = value; }
     }
 
@@ -66,5 +66,5 @@
 
     public SymbolicExpressionTreeNodeEqualityComparer() {
-      matchConstantValues = true;
+      matchParameterValues = true;
       matchVariableNames = true;
       matchVariableWeights = true;
@@ -86,9 +86,9 @@
         return (!MatchVariableNames || va.VariableName.Equals(vb.VariableName)) && (!MatchVariableWeights || va.Weight.Equals(vb.Weight));
       }
-      var ca = a as ConstantTreeNode;
-      if (ca != null) {
-        var cb = b as ConstantTreeNode;
+
+      if (a is INumericTreeNode ca) {
+        var cb = b as INumericTreeNode;
         if (cb == null) return false;
-        return (!MatchConstantValues || ca.Value.Equals(cb.Value));
+        return (!MatchParameterValues || ca.Value.Equals(cb.Value));
       }
       return false;
Index: /trunk/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/OnlineLinearScalingParameterCalculator.cs
===================================================================
--- /trunk/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/OnlineLinearScalingParameterCalculator.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.DataAnalysis/3.4/OnlineCalculators/OnlineLinearScalingParameterCalculator.cs	(revision 18132)
@@ -28,5 +28,5 @@
 
     /// <summary>
-    /// Additive constant
+    /// Additive offset
     /// </summary>
     public double Alpha {
@@ -103,5 +103,5 @@
     /// <param name="original">Values that should be scaled</param>
     /// <param name="target">Target values to which the original values should be scaled</param>
-    /// <param name="alpha">Additive constant for the linear scaling</param>
+    /// <param name="alpha">Additive offset for the linear scaling</param>
     /// <param name="beta">Multiplicative factor for the linear scaling</param>
     /// <param name="errorState">Flag that indicates if errors occurred in the calculation of the linea scaling parameters.</param>
Index: /trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationExpressionGrammar.cs
===================================================================
--- /trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationExpressionGrammar.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationExpressionGrammar.cs	(revision 18132)
@@ -21,4 +21,5 @@
 
 using System.Collections.Generic;
+using System.Linq;
 using HEAL.Attic;
 using HeuristicLab.Common;
@@ -62,10 +63,11 @@
       var or = new Or();
       var not = new Not();
+      var number = new Number();
+      number.MinValue = -20;
+      number.MaxValue = 20;
       var constant = new Constant();
-      constant.MinValue = -20;
-      constant.MaxValue = 20;
       variableSymbol = new HeuristicLab.Problems.DataAnalysis.Symbolic.Variable();
 
-      var allSymbols = new List<Symbol>() { add, sub, mul, div, mean, sin, cos, tan, log, exp, @if, gt, lt, and, or, not, constant, variableSymbol };
+      var allSymbols = new List<Symbol>() { add, sub, mul, div, mean, sin, cos, tan, log, exp, @if, gt, lt, and, or, not, number, constant, variableSymbol };
       var unaryFunctionSymbols = new List<Symbol>() { sin, cos, tan, log, exp, not };
       var binaryFunctionSymbols = new List<Symbol>() { gt, lt };
@@ -86,5 +88,6 @@
 
       SetSubtreeCount(@if, 3, 3);
-      SetSubtreeCount(constant, 0, 0);
+      SetSubtreeCount(number, 0, 0);
+      SetSubtreeCount(constant,0, 0);
       SetSubtreeCount(variableSymbol, 0, 0);
 
@@ -101,4 +104,6 @@
           }
       }
+
+      Symbols.First(s => s is Constant).Enabled = false;
     }
   }
Index: /trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationSymbolicExpressionTreeStringFormatter.cs
===================================================================
--- /trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationSymbolicExpressionTreeStringFormatter.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.ExternalEvaluation.GP/3.5/ExternalEvaluationSymbolicExpressionTreeStringFormatter.cs	(revision 18132)
@@ -106,7 +106,7 @@
           var varNode = node as VariableTreeNode;
           strBuilder.AppendFormat("(* {0} {1})", varNode.VariableName, varNode.Weight.ToString("g17", CultureInfo.InvariantCulture));
-        } else if (node.Symbol is Constant) {
-          var constNode = node as ConstantTreeNode;
-          strBuilder.Append(constNode.Value.ToString("g17", CultureInfo.InvariantCulture));
+        } else if (node.Symbol is INumericSymbol) {
+          var numericNode = node as INumericTreeNode;
+          strBuilder.Append(numericNode.Value.ToString("g17", CultureInfo.InvariantCulture));
         } else {
           throw new NotSupportedException("Formatting of symbol: " + node.Symbol + " not supported for external evaluation.");
Index: /trunk/HeuristicLab.Problems.GrammaticalEvolution/3.4/Mappers/PIGEMapper.cs
===================================================================
--- /trunk/HeuristicLab.Problems.GrammaticalEvolution/3.4/Mappers/PIGEMapper.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.GrammaticalEvolution/3.4/Mappers/PIGEMapper.cs	(revision 18132)
@@ -42,6 +42,6 @@
   ///   integer vector and rule may be one value from a "content" integer vector.
   ///   
-  ///   Order:   NT   = nont % Num. NT      ... determines, which non-terminal to expand next
-  ///   Content: Rule = rule % Num. Rules   ... rule determination as with standard GE mappers
+  ///   Order:   NT   = nont % Number. NT      ... determines, which non-terminal to expand next
+  ///   Content: Rule = rule % Number. Rules   ... rule determination as with standard GE mappers
   /// 
   /// Four mutation and crossover strategies possible:
@@ -155,10 +155,10 @@
           current.AddSubtree(GetRandomTerminalNode(current, grammar, random));
         } else {
-          // Order:   NT   = nont % Num. NT
+          // Order:   NT   = nont % Number. NT
           int nt = NontVector[genotypeIndex] % nonTerminals.Count;
           ISymbolicExpressionTreeNode current = nonTerminals[nt];
           nonTerminals.RemoveAt(nt);
 
-          // Content: Rule = rule % Num. Rules
+          // Content: Rule = rule % Number. Rules
           ISymbolicExpressionTreeNode newNode = GetNewChildNode(current, genotype, grammar, genotypeIndex, random);
           int arity = SampleArity(random, newNode, grammar);
Index: /trunk/HeuristicLab.Problems.GrammaticalEvolution/3.4/SymbolicRegression/GESymbolicExpressionGrammar.cs
===================================================================
--- /trunk/HeuristicLab.Problems.GrammaticalEvolution/3.4/SymbolicRegression/GESymbolicExpressionGrammar.cs	(revision 18131)
+++ /trunk/HeuristicLab.Problems.GrammaticalEvolution/3.4/SymbolicRegression/GESymbolicExpressionGrammar.cs	(revision 18132)
@@ -81,9 +81,4 @@
           var constVal = rand.NextDouble() * 20.0 - 10.0;
           constant.Name = string.Format("{0:0.000}", constVal);
-          constant.MinValue = constVal;
-          constant.MaxValue = constVal;
-          constant.ManipulatorSigma = 0.0;
-          constant.ManipulatorMu = 0.0;
-          constant.MultiplicativeManipulatorSigma = 0.0;
         } while (constants.Any(c => c.Name == constant.Name)); // unlikely, but it could happen that the same constant value is sampled twice. so we resample if necessary.
         constants.Add(constant);
Index: /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicClassificationSampleTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicClassificationSampleTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicClassificationSampleTest.cs	(revision 18132)
@@ -109,10 +109,10 @@
       varSymbol.WeightManipulatorSigma = 0.05;
       varSymbol.MultiplicativeWeightManipulatorSigma = 0.03;
-      var constSymbol = grammar.Symbols.OfType<Constant>().Single();
-      constSymbol.MaxValue = 20;
-      constSymbol.MinValue = -20;
-      constSymbol.ManipulatorMu = 0.0;
-      constSymbol.ManipulatorSigma = 1;
-      constSymbol.MultiplicativeManipulatorSigma = 0.03;
+      var numSymbol = grammar.Symbols.OfType<Number>().Single();
+      numSymbol.MaxValue = 20;
+      numSymbol.MinValue = -20;
+      numSymbol.ManipulatorMu = 0.0;
+      numSymbol.ManipulatorSigma = 1;
+      numSymbol.MultiplicativeManipulatorSigma = 0.03;
       symbClassProblem.SymbolicExpressionTreeGrammar = grammar;
 
Index: /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleTest.cs	(revision 18132)
@@ -110,10 +110,10 @@
       varSymbol.WeightManipulatorSigma = 0.05;
       varSymbol.MultiplicativeWeightManipulatorSigma = 0.03;
-      var constSymbol = grammar.Symbols.OfType<Constant>().Single();
-      constSymbol.MaxValue = 20;
-      constSymbol.MinValue = -20;
-      constSymbol.ManipulatorMu = 0.0;
-      constSymbol.ManipulatorSigma = 1;
-      constSymbol.MultiplicativeManipulatorSigma = 0.03;
+      var numSymbol = grammar.Symbols.OfType<Number>().Single();
+      numSymbol.MaxValue = 20;
+      numSymbol.MinValue = -20;
+      numSymbol.ManipulatorMu = 0.0;
+      numSymbol.ManipulatorSigma = 1;
+      numSymbol.MultiplicativeManipulatorSigma = 0.03;
       symbRegProblem.SymbolicExpressionTreeGrammar = grammar;
 
Index: /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleWithOSTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleWithOSTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GPSymbolicRegressionSampleWithOSTest.cs	(revision 18132)
@@ -66,5 +66,5 @@
         // Unfortunately, running the same test on a different machine results in different values
         // For x86 environments the results below match but on x64 there is a difference
-        // We tracked down the ConstantOptimizationEvaluator as a possible cause but have not
+        // We tracked down the ParameterOptimizationEvaluator as a possible cause but have not
         // been able to identify the real cause. Presumably, execution on a Xeon and a Core i7 processor 
         // leads to different results. 
@@ -184,6 +184,6 @@
       problem.MaximumFunctionArguments.Value = 0;
 
-      var evaluator = new SymbolicRegressionConstantOptimizationEvaluator();
-      evaluator.ConstantOptimizationIterations.Value = 5;
+      var evaluator = new SymbolicRegressionParameterOptimizationEvaluator();
+      evaluator.ParameterOptimizationIterations.Value = 5;
       problem.EvaluatorParameter.Value = evaluator;
       problem.RelativeNumberOfEvaluatedSamplesParameter.Hidden = true;
Index: /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GeSymbolicRegressionSampleTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GeSymbolicRegressionSampleTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/GeSymbolicRegressionSampleTest.cs	(revision 18132)
@@ -113,4 +113,8 @@
         problem.SymbolicExpressionTreeGrammar.RemoveSymbol(c);
       }
+      var numbers = problem.SymbolicExpressionTreeGrammar.AllowedSymbols.OfType<Number>().ToList();
+      foreach (var n in numbers) {
+        problem.SymbolicExpressionTreeGrammar.RemoveSymbol(n);
+      }
 
       SamplesUtils.ConfigureOsGeneticAlgorithmParameters<GenderSpecificSelector, Encodings.IntegerVectorEncoding.SinglePointCrossover, Encodings.IntegerVectorEncoding.UniformOnePositionManipulator>(
Index: /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/ShapeConstrainedRegressionSampleTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/ShapeConstrainedRegressionSampleTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab-3.3/Samples/ShapeConstrainedRegressionSampleTest.cs	(revision 18132)
@@ -35,5 +35,5 @@
   [TestClass]
   public class ShapeConstrainedRegressionSampleTest {
-    private const string SampleFileName = "GA_Shape_Constrained_Regression";
+    private const string SampleFileName = "GP_Shape_Constrained_Regression";
     private static readonly ProtoBufSerializer serializer = new ProtoBufSerializer();
 
@@ -47,7 +47,7 @@
 
       if (Environment.Is64BitProcess) {
-        Assert.AreEqual(0.355347729912352, SamplesUtils.GetDoubleResult(ga, "BestQuality"), 1E-8);
-        Assert.AreEqual(27.6606834433137, SamplesUtils.GetDoubleResult(ga, "CurrentAverageQuality"), 1E-8);
-        Assert.AreEqual(3359.91748220025, SamplesUtils.GetDoubleResult(ga, "CurrentWorstQuality"), 1E-8);
+        Assert.AreEqual(0.035536903914644882, SamplesUtils.GetDoubleResult(ga, "BestQuality"), 1E-8);
+        Assert.AreEqual(26.707437555596698, SamplesUtils.GetDoubleResult(ga, "CurrentAverageQuality"), 1E-8);
+        Assert.AreEqual(3294.1754151628993, SamplesUtils.GetDoubleResult(ga, "CurrentWorstQuality"), 1E-8);
         Assert.AreEqual(150200, SamplesUtils.GetIntResult(ga, "EvaluatedSolutions"));
       } else {
@@ -57,4 +57,13 @@
         Assert.AreEqual(150200, SamplesUtils.GetIntResult(ga, "EvaluatedSolutions"));
       }
+    }
+
+    [TestMethod]
+    [TestCategory("Samples.Create")]
+    [TestProperty("Time", "medium")]
+    public void CreateShapeConstrainedRegressionSampleTest() {
+      var ga = CreateShapeConstrainedRegressionSample();
+      string path = Path.Combine(SamplesUtils.SamplesDirectory, SampleFileName + SamplesUtils.SampleFileExtension);
+      serializer.Serialize(ga, path);
     }
 
@@ -82,5 +91,5 @@
 
       #region Algorithm Configuration
-      alg.Name = "Genetic Programming - Shape constrained Regression";
+      alg.Name = "Genetic Programming - Shape-constrained Regression";
       alg.Description = "A standard genetic programming algorithm to solve a shape constrained regression problem (Radiated gravitational wave power - Feynman instance)";
       alg.Problem = problem;
@@ -93,4 +102,5 @@
 
       alg.Engine = new ParallelEngine.ParallelEngine();
+
       return alg;
     }
Index: /trunk/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/DeriveTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/DeriveTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/DeriveTest.cs	(revision 18132)
@@ -35,14 +35,14 @@
       var formatter = new InfixExpressionFormatter();
       var parser = new InfixExpressionParser();
-      Assert.AreEqual("0", Derive("3", "x"));
+      Assert.AreEqual("0", Derive("<num=3>", "x"));
       Assert.AreEqual("1", Derive("x", "x"));
-      Assert.AreEqual("10", Derive("10*x", "x"));
-      Assert.AreEqual("10", Derive("x*10", "x"));
+      Assert.AreEqual("10", Derive("<num=10>*x", "x"));
+      Assert.AreEqual("10", Derive("x*<num=10>", "x"));
       Assert.AreEqual("(2*'x')", Derive("x*x", "x"));
       Assert.AreEqual("((('x' * 'x') * 2) + ('x' * 'x'))", Derive("x*x*x", "x")); // simplifier does not merge (x*x)*2 + x*x  to 3*x*x
-      Assert.AreEqual("0", Derive("10*x", "y"));
-      Assert.AreEqual("20", Derive("10*x+20*y", "y"));
-      Assert.AreEqual("6", Derive("2*3*x", "x"));
-      Assert.AreEqual("(10*'y')", Derive("10*x*y+20*y", "x"));
+      Assert.AreEqual("0", Derive("<num=10>*x", "y"));
+      Assert.AreEqual("20", Derive("<num=10>*x+<num=20>*y", "y"));
+      Assert.AreEqual("6", Derive("<num=2>*<num=3>*x", "x"));
+      Assert.AreEqual("(10*'y')", Derive("<num=10>*x*y+<num=20>*y", "x"));
       Assert.AreEqual("(1 / (SQR('x') * (-1)))", Derive("1/x", "x"));
       Assert.AreEqual("('y' / (SQR('x') * (-1)))", Derive("y/x", "x"));
@@ -51,14 +51,14 @@
       Assert.AreEqual("((((-2*'x') + (-1)) * ('a' + 'b')) / SQR(('x' + SQR('x'))))", Derive("(a+b)/(x+SQR(x))", "x"));
       Assert.AreEqual("EXP('x')", Derive("exp(x)", "x"));
-      Assert.AreEqual("(EXP((3*'x')) * 3)", Derive("exp(3*x)", "x"));
+      Assert.AreEqual("(EXP((3*'x')) * 3)", Derive("exp(<num=3>*x)", "x"));
       Assert.AreEqual("(1 / 'x')", Derive("log(x)", "x"));
-      Assert.AreEqual("(1 / 'x')", Derive("log(3*x)", "x"));   // 3 * 1/(3*x)
-      Assert.AreEqual("(1 / ('x' + (0.333333333333333*'y')))", Derive("log(3*x+y)", "x"));  // simplifier does not try to keep fractions
-      Assert.AreEqual("(1 / (SQRT(((3*'x') + 'y')) * 0.666666666666667))", Derive("sqrt(3*x+y)", "x"));   // 3 / (2 * sqrt(3*x+y)) = 1 / ((2/3) * sqrt(3*x+y)) 
-      Assert.AreEqual("(COS((3*'x')) * 3)", Derive("sin(3*x)", "x"));
-      Assert.AreEqual("(SIN((3*'x')) * (-3))", Derive("cos(3*x)", "x"));
-      Assert.AreEqual("(1 / (SQR(COS((3*'x'))) * 0.333333333333333))", Derive("tan(3*x)", "x")); // diff(tan(f(x)), x) = 1.0 / cos²(f(x)), simplifier puts constant factor into the denominator
+      Assert.AreEqual("(1 / 'x')", Derive("log(<num=3>*x)", "x"));   // 3 * 1/(3*x)
+      Assert.AreEqual("(1 / ('x' + (0.333333333333333*'y')))", Derive("log(<num=3>*x+y)", "x"));  // simplifier does not try to keep fractions
+      Assert.AreEqual("(1 / (SQRT(((3*'x') + 'y')) * 0.666666666666667))", Derive("sqrt(<num=3>*x+y)", "x"));   // 3 / (2 * sqrt(3*x+y)) = 1 / ((2/3) * sqrt(3*x+y)) 
+      Assert.AreEqual("(COS((3*'x')) * 3)", Derive("sin(<num=3>*x)", "x"));
+      Assert.AreEqual("(SIN((3*'x')) * (-3))", Derive("cos(<num=3>*x)", "x"));
+      Assert.AreEqual("(1 / (SQR(COS((3*'x'))) * 0.333333333333333))", Derive("tan(<num=3>*x)", "x")); // diff(tan(f(x)), x) = 1.0 / cos²(f(x)), simplifier puts constant factor into the denominator
 
-      Assert.AreEqual("((9*'x') / ABS((3*'x')))", Derive("abs(3*x)", "x"));
+      Assert.AreEqual("((9*'x') / ABS((3*'x')))", Derive("abs(<num=3>*x)", "x"));
       Assert.AreEqual("(SQR('x') * 3)", Derive("cube(x)", "x"));
       Assert.AreEqual("(1 / (SQR(CUBEROOT('x')) * 3))", Derive("cuberoot(x)", "x"));
Index: /trunk/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs
===================================================================
--- /trunk/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs	(revision 18131)
+++ /trunk/HeuristicLab.Tests/HeuristicLab.Problems.DataAnalysis.Symbolic-3.4/SymbolicDataAnalysisExpressionCrossoverTest.cs	(revision 18132)
@@ -110,5 +110,5 @@
       grammar.MinimumFunctionDefinitions = 0;
 
-      var trees = Util.CreateRandomTrees(twister, dataset, grammar, PopulationSize, 1, MaxTreeLength, 0, 0);
+      var trees = Util.CreateRandomTrees(twister, dataset, grammar, PopulationSize, MaxTreeLength);
       foreach (ISymbolicExpressionTree tree in trees) {
         Util.InitTree(tree, twister, new List<string>(dataset.VariableNames));
